import { Box } from './box.js';
import { Form } from './form.js';

export class Remark extends Box {
  constructor(doc, text, opts) {
    super('Remark', doc.el, opts);
    this.setInnerHTML(text);
  }
}

/**
 * @example
 * ```typescript
 * const doc = new Document();
 * const form1 = doc.form();
 * ```
 */
export class Document extends Box {
  form() {
    return this.addElement(new Form(this));
  }

  remark(text, opts) {
    return this.addElement(new Remark(this, text, opts));
  }

  addElement(element) {
    this.elements = this.elements ?? [];
    this.elements.push(element);
    return this;
  }

  get lastElement() {
    if (!this.elements?.length) return null;
    return this.elements[this.elements.length - 1];
  }
}
