import { Box } from '../../classes/display/box.js';
// import { Document } from '../../classes/display/document.js';
import { Scene } from '../../classes/display/scene.js';
import { mochaRun } from '../../util/helpers.js';

const rootElement = document.getElementById('scene');
const rootBox = new Box('rootBox', rootElement).flex();
const scene = window.scene = new Scene('Input test', rootBox);

scene.withDocument();

describe('Document', () => {
  it('Exists', () => {
    scene.withDocument('Document', (doc) => doc.remark('Hello'));
  });

  describe('Input', () => {
    it('Accepts input', () => {
      scene.withDocument('Document', (doc) => doc.form());
      const doc = scene.lastDocument;
      const form1 = doc.lastElement;
      const dvMap = new Map();
      const updateFieldValueDisplay = ({ name, value }) => {
        const dv = dvMap.get(name) ?? scene.addDisplayValue(name);
        dvMap.set(name, dv);
        dv.set(value);
      };

      form1.textField({ id: 'input1', name: 'Input 1', cb: updateFieldValueDisplay });
      doc.remark('Hmm...!');
    });
  });
});

mochaRun();
